{{
********************************************
*   SiLabs Si5351 Clock Genreator Driver   *
*                                          *
*     ClockBuilder output file loader      *
*                                          *
*         By Ozpropdev - Jan 2016          *
********************************************
}}


  #0,sda,sck
  
pub load

  dira[sck] :=1
  dira[sda] :=1

  i2c_stop
  send_packet(@list1)
  send_packet(@list2)
  send_regs(15,92)
  send_regs(149,170)
  send_reg(183)
  send_packet(@list3)


pri send_reg(r)

    i2c_start
    i2c_out(%1100000_0)
    wait4ack
    i2c_out(r)  'register address
    wait4ack
    i2c_out(byte[@regmap][r])  'register contents
    wait4ack
    i2c_stop

    
pri send_regs(s,f)|x

    i2c_start
    i2c_out(%1100000_0)
    wait4ack
    i2c_out(s)  'register address
    wait4ack

    repeat x from s to f
      i2c_out(byte[@regmap][x])  'register contents
      wait4ack
    
    i2c_stop

  
pri send_packet(x)
  
  repeat until byte[x] == $ff
    i2c_start
    i2c_out(%1100000_0)
    wait4ack
    i2c_out(byte[x++])  'register address
    wait4ack
    i2c_out(byte[x++])  'register contents
    wait4ack
    i2c_stop

pri i2c_stop

  outa[sck] := 1  
  outa[sda] := 1

pri i2c_start

  outa[sck] := 1  
  outa[sda] := 0
  outa[sck] := 0  

pri i2c_out(b)

  dira[sda] := 1
  
  repeat 8
      outa[sda] := b >> 7
      outa[sck] := 1
      outa[sck] := 0
      b <<= 1
          
pri wait4ack

  dira[sda] := 0   'make pin input
  outa[sck] := 1
  repeat while ina[sda]
  outa[sck] := 0
  dira[sda] := 1  'restore pin to output
  
      
dat

list1   byte    3,$ff   'disable outputs
        byte    16,$80  'powerdown drivers
        byte    17,$80
        byte    18,$80
        byte    19,$80
        byte    20,$80
        byte    21,$80
        byte    22,$80
        byte    23,$80
        byte    $ff

list2   byte    15,$00  'PLL Input Source
        byte    16,$4F  'CLK0 Control
        byte    17,$80  'CLK1 Control
        byte    18,$80  'CLK2 Control
        byte    19,$80  'CLK3 Control
        byte    20,$80  'CLK4 Control
        byte    21,$80  'CLK5 Control
        byte    22,$80  'CLK6 Control
        byte    23,$80  'CLK7 Control
        byte    24,$00  'CLK3_0 Disable State
        byte    25,$00  'CLK7_4 Disable State
        byte    $ff
                        
list3   byte    177,$ac 'soft reset
        byte    3,$f8   'enable outputs
        byte    $ff

'===============================================================================
'paste output from extract here !!!!!!!!!!!!!!!!!!!!!!

'Si5351 Register map
'Extracted from ClockBuilder output file

'#Channel 0 # Output Frequency (MHz) = 67.890000000
'#Channel 1 # Output Frequency (MHz) = 45.670000000
'#Channel 2 # Output Frequency (MHz) = 56.780000000

regmap
        byte    $00,$00,$18,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $6F,$2F,$4F,$80,$80,$80,$80,$80,$00,$00,$02,$71,$00,$0B,$A0,$00
        byte    $01,$60,$02,$71,$00,$0E,$4B,$00,$00,$65,$00,$01,$00,$04,$00,$00
        byte    $00,$00,$11,$D7,$00,$06,$EB,$00,$05,$A3,$00,$01,$00,$04,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$30,$00,$D2,$60,$60,$00,$C0,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0D,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

        