{{
********************************************
*   SiLabs Si5351 Clock Genreator Driver   *
*                                          *
*      ClockBuilder data extractor         *
*                                          *
*         By Ozpropdev - Jan 2016          *
********************************************

Using ClockBuilder :

Select  device "Si5351A on Timing Toolstick"
Set the crystal frequency to 25MHz.
Select desired frequencies and features.
Check configuration with the "Create frequency plan" button
From the "Option" menu select "Save device register(not for factory programming)"
Enter a filename "config.txt" and save to the same folder as the "extract_v1/spin" code.

}}


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


obj

comms: "fullduplexserial"

var

  long  regn,regd

  byte  regs[256]
    
pub main|x,s,ln,tl,i,go,tmp

   go~
   comms.start(31,30,0,115200)
   repeat while ina[31]    'press any key to start

   comms.str(string("'Si5351 Register map",13))
   comms.str(string("'Extracted from ClockBuilder output file",13,13))
   
   tl~
   x := @filedata
   repeat while byte[x] 
     if byte[x] == $0d
        byte[x] := 0
        tl++
     x++


   x := @filedata
   
   repeat until byte[x] == $ff
   
      s := strsize(x)

      getregs(x)

      if tmp
         tmp := false
         comms.tx(32)
         comms.str(x)
         comms.tx(13)
         
      if strcomp(x,string("#Channel 0"))
         comms.tx("'")
         comms.str(x)
         tmp := true

      if strcomp(x,string("#Channel 1"))
         comms.tx("'")
         comms.str(x)
         tmp := true

      if strcomp(x,string("#Channel 2"))
         comms.tx("'")
         comms.str(x)
         tmp := true

     x += s
     x += 2

   'hex dump register map
   comms.str(string(13,"regmap",13))
    
   repeat x from 0 to 255
     if x & $f == 0
        comms.str(string(9,"byte",9))
     comms.tx("$")
     comms.hex(regs[x],2)
     if x & $f <> $f
        comms.tx(",")
     else
        comms.tx(13)      

pri mid(x,s,l)

  x += s
  x--
  repeat l
     comms.tx(byte[x++])

pri getregs(x)|c,t
  t~
  regn~
  regd~

  if byte[x] == "#"
     return
     
  repeat strsize(x)
     c := byte[x++]
     case c
     
       "0".."9": if t
                    regd <<= 4
                    regd += c - 48
                 else
                    regn *= 10
                    regn += c - 48
                       
       "A".."F": regd <<= 4
                 regd += c - ("A" - 10)
                    
       ",": t~~

  regs[regn] := regd
                  
dat

filedata      file "config.txt"
              byte      $0d,$0a,$ff
                        