{{
********************************************
*    SiLabs Si5351 Clock Genreator Demo    *
*                                          *
*  Basic single channel - 2MHz to 150MHz   *
*                                          *
*         By Ozpropdev - Jan 2016          *
********************************************
}}

con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  #0,sda,sck

  sample_pin = 5

obj

si5351: "si5351_spin_driver_v1"
comms: "fullduplexserial"
        
pub main|value,char_in,digit_count,dot,q,mfreq

  si5351.set_pins(sda,sck)
  comms.start(31,30,0,115200)
  repeat while ina[31]          'wait for key press

  comms.str(string(16,"Si5351 Clock Generator test",13))

  frqa := 1
  ctra := %01010 << 26 | sample_pin

  repeat
  
      comms.str(string("Enter frequency in MHz? "))
      value~
      digit_count~
      dot~
      
      repeat
        char_in := comms.rx

        case char_in
        
          "0".."9": value *= 10
                    value += char_in-48
                    comms.tx(char_in)
                    digit_count++
                
          13: comms.tx(char_in)
              quit

          8:  if digit_count
                 if digit_count == dot
                    dot~
                    comms.tx(char_in)
                 else   
                   value /= 10
                   comms.tx(char_in)
                   digit_count--
                 
          ".":   ifnot dot
                       dot := digit_count
                       comms.tx(char_in)


      if dot == 0 and digit_count < 4
        value *= 1_000_000
      elseif dot
         q := 7 + dot
         q -= digit_count   
         value *= lookup(q:1,10,100,1_000,10_000,100_000,1_000_000,10_000_000)

      comms.str(string(" Set to "))   
      comms.dec(value)
      comms.str(string(" Hz",13))
             
      si5351.set_freq(value)

      comms.str(string(" Measured freq. = ")) 

      if value < 37_000_000
      
          q := cnt          'sample freq. 3 times
          repeat 3
            q += clkfreq
            waitcnt(q)
            mfreq := phsa~

          comms.dec(mfreq)
          comms.str(string(" Hz",13))

      else
      
          comms.str(string("Out of range",13))
        